// Luc Hanneuse CC BY NC 4.0
PrintWriter output;// to write to a file
float z = 0.1;
float x = 100.0;
float y = 100.0;
float step = 0.3;
float e = 5.0;

void setup() {
  output = createWriter("mysuper.gcode"); // Create a new file in the sketch directory
  //output.println("G21"); // header gcode
  //output.println("G91"); // header gcode
  //output.println("M109 S220");
  output.println("G4 1000");
  output.println("M83"); //extrusion relative
  output.println("G1 F1000 E10.0");
  output.println("G1 X" + x + " Y" + y + " Z" + z + " E1.0");
  
  size(640, 360);
  
  square(20 , 30);//create a square
  //translate(1 , 1);//translate
  //square(20 , 30);
  
}

void draw() {
  background(102);
  translate(width*0.5, height*0.5);
  
}

void keyPressed() {
  output.println("G1 X100.0 Y100.0 Z20.0");//move head to z20
  output.flush(); // Writes the remaining data to the file
  output.close(); // Finishes the file
  exit(); // Stops the program
}

void square(float wide, float lenght) {
  writegcode();
  x = x + wide;
  writegcode();
  y = y + lenght;
  writegcode();
  x = x - wide;
  writegcode();
  y = y - lenght;
}

void translate(float xmove, float ymove){
  x = x + xmove;
  y = y + ymove;
}

void writegcode(){
  output.println("G1 X" + x + " Y" + y + " Z" + z + " E" + e );
  //G1 F3000 X100 Y100 Z0.3 E20 typical gcode
}
